SystemOrganization addCategory: #'Rest-Example'!

RestProxyRepository subclass: #LibraryProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Example'!

!LibraryProxy methodsFor: 'add-remove' stamp: 'cs 6/5/2009 13:07'!
addNewBook: aDictionary

	^ self books addNew: aDictionary! !

!LibraryProxy methodsFor: 'add-remove' stamp: 'cs 6/5/2009 13:07'!
addNewCustomer: aDictionary

	^ self customers addNew: aDictionary! !

!LibraryProxy methodsFor: 'accessing' stamp: 'cs 6/5/2009 13:03'!
books

	^ self getCollection: '/books/'! !

!LibraryProxy methodsFor: 'accessing' stamp: 'cs 6/5/2009 13:03'!
customers

	^ self getCollection: '/customers/'! !

!LibraryProxy methodsFor: 'add-remove' stamp: 'cs 6/5/2009 13:06'!
removeBook: aBook

	aBook delete.! !

!LibraryProxy methodsFor: 'add-remove' stamp: 'cs 6/5/2009 13:06'!
removeCustomer: aCustomer

	aCustomer delete.! !

RestEntity subclass: #Book
	instanceVariableNames: 'author title daysBorrowed customer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Example'!

!Book class methodsFor: 'accessing' stamp: 'cs 5/20/2009 15:37'!
handlerClass
	self shouldBeImplemented! !

!Book class methodsFor: 'instance creation' stamp: 'cs 5/19/2009 19:03'!
newFrom: aDictionary

	^ self new
		author: (aDictionary at: 'author' ifAbsent: []);
		title: (aDictionary at: 'title')! !

!Book class methodsFor: 'description' stamp: 'cs 6/5/2009 13:47'!
primitivePropertyNames

	^ super primitivePropertyNames, #(author title daysBorrowed)! !

!Book class methodsFor: 'description' stamp: 'cs 5/20/2009 15:32'!
referencePropertyNames

	^ super referencePropertyNames, #(customer)! !

!Book methodsFor: 'accessing' stamp: 'cs 5/19/2009 18:43'!
author

	^ author! !

!Book methodsFor: 'accessing' stamp: 'cs 5/19/2009 18:43'!
author: anObject

	author := anObject.! !

!Book methodsFor: 'accessing' stamp: 'cs 5/20/2009 15:32'!
customer

	^ customer! !

!Book methodsFor: 'accessing' stamp: 'cs 6/5/2009 11:56'!
customer: aCustomer

	self customer = aCustomer ifTrue: [^ self]. "to avoid infinite recursion"
	self customer ifNotNil:
		[self customer removeBorrowedBook: self].
	customer := aCustomer.
	self customer ifNotNil:
		[self customer addBorrowedBook: self].! !

!Book methodsFor: 'accessing' stamp: 'cs 6/5/2009 13:47'!
daysBorrowed

	^ daysBorrowed! !

!Book methodsFor: 'accessing' stamp: 'cs 6/5/2009 13:47'!
daysBorrowed: anObject

	daysBorrowed := anObject.! !

!Book methodsFor: 'deleting' stamp: 'cs 6/4/2009 13:43'!
delete
	
	self customer ifNotNil: [self customer removeBorrowedBook: self].
	self handler root removeBook: self.! !

!Book methodsFor: 'initialization' stamp: 'cs 6/5/2009 13:50'!
initialize

	super initialize.
	self daysBorrowed: 0.! !

!Book methodsFor: 'accessing' stamp: 'cs 5/19/2009 18:43'!
title

	^ title! !

!Book methodsFor: 'accessing' stamp: 'cs 5/19/2009 18:43'!
title: anObject

	title := anObject.! !

RestEntity subclass: #Customer
	instanceVariableNames: 'firstname lastname borrowedBooks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Example'!

!Customer class methodsFor: 'description' stamp: 'cs 5/19/2009 17:58'!
collectionPropertyNames

	^ super collectionPropertyNames, #(borrowedBooks)! !

!Customer class methodsFor: 'accessing' stamp: 'cs 5/20/2009 15:12'!
handlerClass
	self shouldBeImplemented! !

!Customer class methodsFor: 'instance creation' stamp: 'cs 5/19/2009 18:56'!
newFrom: aDictionary

	^ self new
		firstname: (aDictionary at: 'firstname');
		lastname: (aDictionary at: 'lastname')! !

!Customer class methodsFor: 'description' stamp: 'cs 5/19/2009 19:03'!
primitivePropertyNames

	^ super primitivePropertyNames, #(firstname lastname)! !

!Customer methodsFor: 'add-remove' stamp: 'cs 6/4/2009 13:28'!
addBorrowedBook: aBook

	self borrowedBooks add: aBook ifPresent: [^ aBook].
	^ aBook
		customer: self;
		yourself! !

!Customer methodsFor: 'accessing' stamp: 'cs 5/19/2009 17:56'!
borrowedBooks

	^ borrowedBooks! !

!Customer methodsFor: 'accessing' stamp: 'cs 5/19/2009 17:56'!
borrowedBooks: anObject

	borrowedBooks := anObject.! !

!Customer methodsFor: 'deleting' stamp: 'cs 6/4/2009 13:30'!
delete

	self borrowedBooks do: [:book | book customer: nil].
	self handler root removeCustomer: self.! !

!Customer methodsFor: 'accessing' stamp: 'cs 5/19/2009 17:56'!
firstname

	^ firstname! !

!Customer methodsFor: 'accessing' stamp: 'cs 5/19/2009 17:56'!
firstname: anObject

	firstname := anObject.! !

!Customer methodsFor: 'initialization' stamp: 'cs 6/5/2009 11:55'!
initialize

	super initialize.
	self borrowedBooks: OrderedCollection new.! !

!Customer methodsFor: 'accessing' stamp: 'cs 5/19/2009 17:56'!
lastname

	^ lastname! !

!Customer methodsFor: 'accessing' stamp: 'cs 5/19/2009 17:56'!
lastname: anObject

	lastname := anObject.! !

!Customer methodsFor: 'add-remove' stamp: 'cs 5/20/2009 15:33'!
removeBorrowedBook: aBook

	self borrowedBooks remove: aBook ifAbsent: [^ aBook].
	^ aBook
		customer: nil;
		yourself! !

RestEntity subclass: #Library
	instanceVariableNames: 'books customers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Example'!

Library class
	instanceVariableNames: 'production'!

Library class
	instanceVariableNames: 'production'!

!Library class methodsFor: 'resources' stamp: 'cs 5/28/2009 15:29'!
collectionPropertyNames

	^ #(customers books)! !

!Library class methodsFor: 'accessing' stamp: 'cs 6/5/2009 11:28'!
production

	^ production ifNil: [production := Library new]! !

!Library class methodsFor: 'accessing' stamp: 'cs 6/5/2009 11:27'!
production: anObject

	production := anObject.! !

!Library methodsFor: 'add-remove' stamp: 'cs 6/4/2009 13:09'!
addBook: aBook

	self books add: aBook.
	^ aBook
		id: Book incrementId;
		handler: self handler! !

!Library methodsFor: 'add-remove' stamp: 'cs 6/4/2009 13:01'!
addCustomer: aCustomer

	self customers add: aCustomer.
	^ aCustomer
		id: Customer incrementId;
		handler: self handler! !

!Library methodsFor: 'add-remove' stamp: 'cs 6/4/2009 15:39'!
addNewBook: aBook

	^ self addBook: (Book newFrom: aBook)! !

!Library methodsFor: 'add-remove' stamp: 'cs 6/4/2009 15:40'!
addNewCustomer: aCustomer

	^ self addCustomer: (Customer newFrom: aCustomer)! !

!Library methodsFor: 'accessing' stamp: 'cs 5/27/2009 16:49'!
books

	^ books! !

!Library methodsFor: 'accessing' stamp: 'cs 5/27/2009 16:49'!
books: anObject

	books := anObject.! !

!Library methodsFor: 'accessing' stamp: 'cs 5/27/2009 16:49'!
customers

	^ customers! !

!Library methodsFor: 'accessing' stamp: 'cs 5/27/2009 16:49'!
customers: anObject

	customers := anObject.! !

!Library methodsFor: 'initialization' stamp: 'cs 5/27/2009 16:49'!
initialize

	super initialize.
	self
		books: OrderedCollection new;
		customers: OrderedCollection new.! !

!Library methodsFor: 'add-remove' stamp: 'cs 6/5/2009 11:03'!
removeBook: aBook
	
	^ self books remove: aBook! !

!Library methodsFor: 'add-remove' stamp: 'cs 6/4/2009 12:59'!
removeCustomer: aCustomer
	
	^ self customers remove: aCustomer! !

StandardWindow subclass: #LibraryClient
	instanceVariableNames: 'bookList selectedIndex titleEntry authorEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Example'!

!LibraryClient class methodsFor: 'instance creation' stamp: 'cs 6/5/2009 14:11'!
openLocal

	self new
		model: Library production;
		openInWorld! !

!LibraryClient class methodsFor: 'instance creation' stamp: 'cs 6/5/2009 14:11'!
openRemote

	self new
		model: (LibraryProxy fromString: 'http://localhost:8082/library');
		openInWorld! !

!LibraryClient methodsFor: 'actions' stamp: 'cs 6/5/2009 10:57'!
addBook

	| book |
	book := self model addNewBook: (Dictionary
		with: 'title' -> 'New Book'
		with: 'author' -> 'No Author').
	self selectedIndex: (self model books indexOf: book).
	self changed: #bookTitles.! !

!LibraryClient methodsFor: 'user interface' stamp: 'cs 6/5/2009 10:33'!
addButton

	^ self
		newButtonFor: self
		action: #addBook
		label: 'Add Book'
		help: 'Adds a new book to the library'! !

!LibraryClient methodsFor: 'accessing' stamp: 'cs 6/5/2009 10:38'!
authorEntry

	authorEntry ifNil: [self authorEntry: (self
		newTextEntryFor: self
		getText: #selectedAuthor
		setText: #selectedAuthor:
		getEnabled: #isSelected
		help: 'Author of the book')].
	^ authorEntry! !

!LibraryClient methodsFor: 'accessing' stamp: 'cs 6/5/2009 10:31'!
authorEntry: anEntry

	authorEntry := anEntry.! !

!LibraryClient methodsFor: 'accessing' stamp: 'cs 6/5/2009 10:32'!
bookDetails

	^ self newColumn: {
		self newRow: {self newLabel: 'Name:'. self titleEntry}.
		self newRow: {self newLabel: 'Author:'. self authorEntry}.
		self newRow: {self saveButton}}! !

!LibraryClient methodsFor: 'accessing' stamp: 'cs 6/4/2009 15:57'!
bookList

	bookList ifNil: [self bookList:
		(self
			newListFor: self
			list: #bookTitles
			selected: #selectedIndex
			changeSelected: #selectedIndex:
			help: 'All books of the library')].
	^ bookList! !

!LibraryClient methodsFor: 'accessing' stamp: 'cs 6/4/2009 15:04'!
bookList: aCollection

	bookList := aCollection.! !

!LibraryClient methodsFor: 'accessing' stamp: 'cs 6/4/2009 15:44'!
bookTitles

	^ self model
		ifNil: [#()]
		ifNotNil: [self model books
			collect: [:book | book title, ' by ', book author]]! !

!LibraryClient methodsFor: 'actions' stamp: 'cs 6/5/2009 11:01'!
deleteBook

	self model removeBook: self selectedBook.
	self selectedIndex: 0.
	self changed: #bookTitles.! !

!LibraryClient methodsFor: 'user interface' stamp: 'cs 6/5/2009 10:36'!
deleteButton

	^ self
		newButtonFor: self
		action: #deleteBook
		getEnabled: #isSelected
		label: 'Delete'
		help: 'Deletes the selected book from the library'! !

!LibraryClient methodsFor: 'initialization' stamp: 'cs 6/5/2009 10:42'!
initialize

	super initialize.
	self selectedIndex: 0.
	self addMorph: (self newRow: {
		self newColumn: {self bookList. self newRow: {self addButton. self deleteButton}}.
		self bookDetails.
	})	frame: (0@0 corner: 1@1).! !

!LibraryClient methodsFor: 'accessing' stamp: 'cs 6/5/2009 10:41'!
isSelected

	^ selectedIndex > 0! !

!LibraryClient methodsFor: 'model' stamp: 'cs 6/5/2009 14:06'!
model: aModel

	super model: aModel.
	self changed: #bookTitles.! !

!LibraryClient methodsFor: 'user interface' stamp: 'cs 6/4/2009 14:56'!
quitButton

	^ self
		newButtonFor: self
		action: #delete
		label: 'Quit'
		help: 'Closes the library administration'! !

!LibraryClient methodsFor: 'actions' stamp: 'cs 6/5/2009 10:39'!
saveBook

	self titleEntry accept.
	self authorEntry accept.
	self changed: #bookTitles.! !

!LibraryClient methodsFor: 'user interface' stamp: 'cs 6/5/2009 10:38'!
saveButton

	^ self
		newButtonFor: self
		action: #saveBook
		getEnabled: #isSelected
		label: 'Save'
		help: 'Saves the changes of the book'! !

!LibraryClient methodsFor: 'accessing' stamp: 'cs 6/5/2009 10:49'!
selectedAuthor

	^ self selectedBook
		ifNil: ['']
		ifNotNilDo: [:book | book author]! !

!LibraryClient methodsFor: 'accessing' stamp: 'cs 6/5/2009 10:22'!
selectedAuthor: aString

	^ self selectedBook author: aString! !

!LibraryClient methodsFor: 'accessing' stamp: 'cs 6/5/2009 10:56'!
selectedBook

	^ (self isSelected and: [self model notNil])
		ifTrue: [self model books at: self selectedIndex]
		ifFalse: []! !

!LibraryClient methodsFor: 'accessing' stamp: 'cs 6/4/2009 15:55'!
selectedIndex

	^ selectedIndex! !

!LibraryClient methodsFor: 'accessing' stamp: 'cs 6/5/2009 10:59'!
selectedIndex: index

	selectedIndex := index.
	self
		changed: #selectedIndex;
		changed: #selectedTitle;
		changed: #selectedAuthor;
		changed: #isSelected.! !

!LibraryClient methodsFor: 'accessing' stamp: 'cs 6/5/2009 10:48'!
selectedTitle

	^ self selectedBook
		ifNil: ['']
		ifNotNilDo: [:book | book title]! !

!LibraryClient methodsFor: 'accessing' stamp: 'cs 6/5/2009 10:20'!
selectedTitle: aString

	self selectedBook title: aString.! !

!LibraryClient methodsFor: 'controls' stamp: 'cs 6/5/2009 11:02'!
title

	^ 'Library Administration'! !

!LibraryClient methodsFor: 'accessing' stamp: 'cs 6/5/2009 10:38'!
titleEntry

	titleEntry ifNil: [self titleEntry: (self
		newTextEntryFor: self
		getText: #selectedTitle
		setText: #selectedTitle:
		getEnabled: #isSelected
		help: 'Title for the book')].
	^ titleEntry! !

!LibraryClient methodsFor: 'accessing' stamp: 'cs 6/5/2009 10:28'!
titleEntry: anEntry

	titleEntry := anEntry.! !

RestResourceHttpHandler subclass: #LibraryHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rest-Example'!

!LibraryHandler class methodsFor: 'testing' stamp: 'cs 5/20/2009 19:33'!
canBeAutostarted

	^ true! !

!LibraryHandler class methodsFor: 'handling' stamp: 'cs 6/4/2009 14:21'!
pathPattern

	^ 'library'! !

!LibraryHandler class methodsFor: 'resources' stamp: 'cs 6/5/2009 11:28'!
rootResource

	^ Library production! !

!LibraryHandler class methodsFor: 'resources' stamp: 'cs 6/5/2009 13:39'!
uriMapping
	
	^ Dictionary
		with: Customer -> [:customer | '/customers/', customer id asString]
		with: Book -> [:book | '/books/', book id asString]! !
